LIBRARY ieee ;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY banker_tester IS
        Generic (n         :integer :=3);
        PORT (Clk          : OUT STD_LOGIC;
              Reset        : OUT STD_LOGIC;
              playerId     : OUT STD_LOGIC_VECTOR (n-1 downto 0); -- from
              Action       : OUT STD_LOGIC_VECTOR (2*n-3 downto 0); --from scorer 
              TakeAction   : OUT STD_LOGIC; 
              cgNewHand    : OUT STD_LOGIC;         
              bet          : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
 
              balance      : IN STD_LOGIC_VECTOR (11 downto 0); --Max1024
              GameOver     : IN STD_LOGIC; -- The whole game is over
              balancerdy   : IN STD_LOGIC);

            
END banker_tester;


ARCHITECTURE test OF banker_tester IS
-- General Out-- Architecture declarations
CONSTANT clk_prd : time := 100 ns;
SIGNAL iclk : std_logic;

PROCEDURE wait_clock(CONSTANT clk_ticks:integer) IS
VARIABLE i : integer := 0;
BEGIN
   FOR i IN 0 TO clk_ticks LOOP
      WAIT UNTIL rising_edge(iclk);
   END LOOP;
END wait_clock;

BEGIN
Main :Process

BEGIN
       --Initialization
        Reset <= '0';
	Action <=  (OTHERS => '0');
	PlayerId <= (OTHERS => '0');
	TakeAction <= '0';
	bet <= (OTHERS=>'0');
	wait_clock(10);

	Reset <= '1';
	wait_clock(10);
	wait_clock(10);

	Reset <= '0';
	cgNewHand <= '1';
	PlayerId <= "001";     --assUMe 3 players
	bet <= "000000000011"; --make this small
	wait_clock(5);
	
	cgNewHand <= '0';
	PlayerId <= "010";
	bet <= "000000000101"; --make this also small
	wait_clock(5);
	wait_clock(5);
	
	Action <= "0100";
	wait_clock(3);
	TakeAction <= '1';
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	


	TakeAction <= '1';
		PlayerId <= "001";  Action <= "0010"; 
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	

	TakeAction <= '1';	PlayerId <= "010"; Action <= "0101";  
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	

	TakeAction <= '1';	PlayerId <= "001";   
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	

        Action <= "0100";
	wait_clock(3);
	TakeAction <= '1';
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	


	TakeAction <= '1';
		PlayerId <= "001";  Action <= "0010"; 
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	

	TakeAction <= '1';	PlayerId <= "010"; Action <= "0101";  
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	

	TakeAction <= '1';	PlayerId <= "001";   
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	
	
	Action <= "0100";
	wait_clock(3);
	TakeAction <= '1';
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	


	TakeAction <= '1';
		PlayerId <= "001";  Action <= "0010"; 
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	

	TakeAction <= '1';	PlayerId <= "010"; Action <= "0101";  
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	

	TakeAction <= '1';	PlayerId <= "001";   
	wait_clock (1);
	TakeAction <= '0';	
	wait_clock(5);	
	
end process main;
-- Architecture concurrent statements
-- Clock generator
ClockGen : PROCESS
BEGIN
   iclk <= '0';
   WAIT FOR clk_prd/2;
   iclk <= '1';
   WAIT FOR clk_prd/2;
END PROCESS ClockGen;
clk <= iclk;

END test;
	

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.all;
ENTITY banker_tb IS
-- Test bench has no external interface
GENERIC (n      :INTEGER := 3); -- Number of players
END banker_tb ;
ARCHITECTURE struct OF banker_tb IS
signal Clk             : STD_LOGIC;  -- Global Clk
signal Reset           : STD_LOGIC;  -- Global Reset
signal  bet          :  STD_LOGIC_VECTOR (11 DOWNTO 0);
signal  balance      :  STD_LOGIC_VECTOR (11 downto 0); --Max1024
signal  balancerdy   :  STD_LOGIC;
signal PlayerId        :STD_LOGIC_VECTOR (n-1 downto 0);
signal cgNewHand       : STD_LOGIC; -- New hand  
signal GameOver      : STD_LOGIC;
signal Action          : STD_LOGIC_VECTOR (2*n-3 downto 0);-- Output to the Banker
signal	TakeAction      : STD_LOGIC   ;
COMPONENT banker

 PORT (Clk          : IN STD_LOGIC;
              Reset        : IN STD_LOGIC;
              playerId     : IN STD_LOGIC_VECTOR (n-1 downto 0); -- from
              Action       : IN STD_LOGIC_VECTOR (2*n-3 downto 0); --from scorer 
              TakeAction   : IN STD_LOGIC; 
              cgNewHand    : IN STD_LOGIC;         
              bet          : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
 
              balance      : OUT STD_LOGIC_VECTOR (11 downto 0); --Max1024
              GameOver     : OUT STD_LOGIC; -- The whole game is over
              balancerdy   : OUT STD_LOGIC);

END COMPONENT;

COMPONENT banker_tester

PORT (Clk          : OUT STD_LOGIC;
              Reset        : OUT STD_LOGIC;
              playerId     : OUT STD_LOGIC_VECTOR (n-1 downto 0); -- from
              Action       : OUT STD_LOGIC_VECTOR (2*n-3 downto 0); --from scorer 
              TakeAction   : OUT STD_LOGIC; 
              cgNewHand    : OUT STD_LOGIC;         
              bet          : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
 
              balance      : IN STD_LOGIC_VECTOR (11 downto 0); --Max1024
              GameOver     : IN STD_LOGIC; -- The whole game is over
              balancerdy   : IN STD_LOGIC);

END COMPONENT;
BEGIN
UUT: banker 
     PORT MAP (
    	Clk=>Clk,
	Reset => Reset,
	playerId=>playerId,
	Action=> Action,
	cgNewHand => cgNewHand,
	GameOver => GameOver,
	bet => bet,
	balance => balance,
	balancerdy => balancerdy,
	TakeAction => TakeAction
);
Checker: banker_tester
	PORT MAP (
	Clk=>Clk,
	Reset => Reset,
	playerId=>playerId,
	Action=> Action,
	cgNewHand => cgNewHand,
	GameOver => GameOver,
	bet => bet,
	balance => balance,
	balancerdy => balancerdy,
	TakeAction => TakeAction
);
END struct;
